/*
 * sample-document.h
 *
 * Copyright (C) 2013 Hodong Kim <cogniti@gmail.com>
 * 
 * sample-document.h is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * sample-document.h is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SAMPLE_DOCUMENT_H__
#define __SAMPLE_DOCUMENT_H__

#include <glib-object.h>
#include <evince-document.h>

G_BEGIN_DECLS

#define SAMPLE_TYPE_DOCUMENT            (sample_document_get_type ())
#define SAMPLE_DOCUMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), SAMPLE_TYPE_DOCUMENT, SampleDocument))
#define SAMPLE_DOCUMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  SAMPLE_TYPE_DOCUMENT, SampleDocumentClass))
#define SAMPLE_IS_DOCUMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SAMPLE_TYPE_DOCUMENT))
#define SAMPLE_IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  SAMPLE_TYPE_DOCUMENT))
#define SAMPLE_DOCUMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  SAMPLE_TYPE_DOCUMENT, SampleDocumentClass))

typedef struct _SampleDocument      SampleDocument;
typedef struct _SampleDocumentClass SampleDocumentClass;

GType sample_document_get_type (void) G_GNUC_CONST;

G_MODULE_EXPORT GType register_evince_backend (GTypeModule *module);

G_END_DECLS

#endif /* __SAMPLE_DOCUMENT_H__ */
