/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * example
 * Copyright (C) Hodong Kim 2013 <cogniti@debian>
 * 
 * example is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * example is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.";
 */

#ifndef _EXAMPLE_DOCUMENT_H_
#define _EXAMPLE_DOCUMENT_H_

#include <glib-object.h>
#include "example-page.h"

G_BEGIN_DECLS

#define EXAMPLE_TYPE_DOCUMENT             (example_document_get_type ())
#define EXAMPLE_DOCUMENT(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), EXAMPLE_TYPE_DOCUMENT, ExampleDocument))
#define EXAMPLE_DOCUMENT_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), EXAMPLE_TYPE_DOCUMENT, ExampleDocumentClass))
#define EXAMPLE_IS_DOCUMENT(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EXAMPLE_TYPE_DOCUMENT))
#define EXAMPLE_IS_DOCUMENT_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), EXAMPLE_TYPE_DOCUMENT))
#define EXAMPLE_DOCUMENT_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), EXAMPLE_TYPE_DOCUMENT, ExampleDocumentClass))

typedef struct _ExampleDocumentClass ExampleDocumentClass;
typedef struct _ExampleDocument      ExampleDocument;

struct _ExampleDocumentClass
{
	GObjectClass parent_class;
};

struct _ExampleDocument
{
	GObject      parent_instance;
	ExamplePage *page;
};

GType            example_document_get_type     (void) G_GNUC_CONST;
ExampleDocument *example_document_new_from_uri (const gchar *uri,
                                                GError **error);
guint            example_document_get_n_pages  (ExampleDocument *document);
ExamplePage     *example_document_get_page     (ExampleDocument *document,
                                                gint index);

G_END_DECLS

#endif /* _EXAMPLE_DOCUMENT_H_ */
