/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * example
 * Copyright (C) Hodong Kim 2013 <cogniti@gmail.com>
 * 
 * example is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * example is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.";
 */

#ifndef _EXAMPLE_PAGE_H_
#define _EXAMPLE_PAGE_H_

#include <glib-object.h>
#include <cairo.h>

G_BEGIN_DECLS

#define EXAMPLE_TYPE_PAGE             (example_page_get_type ())
#define EXAMPLE_PAGE(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), EXAMPLE_TYPE_PAGE, ExamplePage))
#define EXAMPLE_PAGE_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), EXAMPLE_TYPE_PAGE, ExamplePageClass))
#define EXAMPLE_IS_PAGE(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EXAMPLE_TYPE_PAGE))
#define EXAMPLE_IS_PAGE_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), EXAMPLE_TYPE_PAGE))
#define EXAMPLE_PAGE_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), EXAMPLE_TYPE_PAGE, ExamplePageClass))

typedef struct _ExamplePageClass ExamplePageClass;
typedef struct _ExamplePage      ExamplePage;

struct _ExamplePageClass
{
	GObjectClass parent_class;
};

struct _ExamplePage
{
	GObject parent_instance;
};

GType        example_page_get_type   (void) G_GNUC_CONST;
void         example_page_get_size   (ExamplePage *page,
                                      gdouble     *width,
                                      gdouble     *height);
gboolean     example_page_render     (ExamplePage *page, cairo_t *cr);

G_END_DECLS

#endif /* _EXAMPLE_PAGE_H_ */
